
public class GBApu {

	private static final int BASEFREQ = 131072;
	private static final int BASEFREQ2 = BASEFREQ >> 1;

	//MLDo͗p
	private final PSGi psgi;
	private static final int CH1_BANKNUM[] = { 0,1,2,1 };
	private static final int CH2_BANKNUM[] = { 0,1,2,1 };
	private static final int CH3_BANKNUM = 0;
	private static final int CH4_BANKNUM[] = { 4, 4 };
	private static final int CH1_VOL[] = { 0,7,10,14,19,22,25,28,32,34,36,38,40,42,44,46 };
	private static final int CH2_VOL[] = { 0,7,10,14,19,22,25,28,32,34,36,38,40,42,44,46 };
	private static final int CH3_VOL[] = { 0, 40, 20, 10 };
	private static final int CH4_VOL[] = { 0,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22 };
	private static final int CH_PAN[] = { 0,63,1,32 };
	
	//TEhpIOWX^
	private final int ram_hi[];
	private final int ch3_wave[];
	
	//eTEhWX^p[^
	//(x債Ă񂾂낤CiNXgقǂH
	private int ch1_swplen;
	private int ch1_swpdir;
	private int ch1_swpdep;
	private int ch1_duty;
	private int ch1_len;
	private int ch1_envvol;
	private int ch1_envlen;
	private int ch1_envdir;
	private int ch1_cntflag;
	private int ch1_outflag;
	private int ch1_cnt;
	private int ch1_envcnt;
	private int ch1_swpcnt;
	private int ch1_freq;
	private int ch1_divclock;
	private int ch1_pan;

	private int ch2_duty;
	private int ch2_len;
	private int ch2_envvol;
	private int ch2_envlen;
	private int ch2_envdir;
	private int ch2_cntflag;
	private int ch2_outflag;
	private int ch2_cnt;
	private int ch2_envcnt;
	private int ch2_freq;
	private int ch2_pan;
	
	private int ch3_len;
	private int ch3_cntflag;
	private int ch3_outflag;
	private int ch3_cnt;
	private int ch3_outlvl;
	private int ch3_freq;
	private int ch3_pan;

	private int ch4_len;
	private int ch4_envvol;
	private int ch4_envlen;
	private int ch4_envdir;
	private int ch4_siftclock;
	private int ch4_seqmode;
	private int ch4_divratio;
	private int ch4_cntflag;
	private int ch4_outflag;
	private int ch4_cnt;
	private int ch4_envcnt;
	private int ch4_freq;
	private int ch4_pan;


	private void ch1init() {
		ch1_envvol = ram_hi[0x12] >> 4;
		ch1_envdir = (ram_hi[0x12] >> 3) & 0x01;
		ch1_envdir |= ch1_envdir - 1;
		ch1_envlen = (ram_hi[0x12] & 0x07);

		ch1_outflag = 1;
		ch1_cnt = ch1_len * 60;		//|ZłcHB
		ch1_envcnt = ch1_envlen * 60;
		ch1_swpcnt = ch1_swplen * 60;
	}

	private void ch2init() {
		ch2_envvol = ram_hi[0x17] >> 4;
		ch2_envdir = (ram_hi[0x17] >> 3) & 0x01;
		ch2_envdir |= ch2_envdir - 1;
		ch2_envlen = (ram_hi[0x17] & 0x07);

		ch2_outflag = 1;
		ch2_cnt = ch2_len * 60;
		ch2_envcnt = ch2_envlen * 60;
	}

	private void ch3init() {
		ch3_outflag = ram_hi[0x1A] >> 7;
		ch3_cnt = ch3_len * 60;
	}

	private void ch4init() {
		ch4_envvol = ram_hi[0x21] >> 4;
		ch4_envdir = (ram_hi[0x21] >> 3) & 0x01;
		ch4_envdir |= ch4_envdir - 1;
		ch4_envlen = (ram_hi[0x21] & 0x07);

		ch4_outflag = 1;
		ch4_cnt = ch4_len * 60;
		ch4_envcnt = ch4_envlen * 60;
	}
	
	private void ch1freq() {
		int d;

		ch1_divclock = ((ram_hi[0x14] & 0x07) << 8) + ram_hi[0x13];
		d = 2048 - ch1_divclock;
		ch1_freq = (BASEFREQ + (d >> 1)) / d;;
		//]؎̂Č덷܂BB
		//1hz̍ő傫ɂȂ̂͒g悾Ȃ̂
		//Ȃł悩낤(KB
	}

	private void ch2freq() {
		int d;

		d = 2048 - (((ram_hi[0x19] & 0x07) << 8) + ram_hi[0x18]);
		ch2_freq = (BASEFREQ + (d >> 1)) / d;
	}
	private void ch3freq() {
		int d;

		d = 2048 - (((ram_hi[0x1E] & 0x07) << 8) + ram_hi[0x1D]);
		ch3_freq = (BASEFREQ2 + (d >> 1)) / d;
	}

	private void ch4freq() {
		ch4_freq = ch4_siftclock * ch4_divratio;
	}

	void init() {
		reset();
		ram_hi[0x10] = 0x80;
		ram_hi[0x11] = 0xBF;
		ram_hi[0x12] = 0xF3;
		ram_hi[0x14] = 0xBF;
		ram_hi[0x16] = 0x3F;
		ram_hi[0x17] = 0x00;
		ram_hi[0x19] = 0xBF;
		ram_hi[0x1A] = 0x7F;
		ram_hi[0x1B] = 0xFF;
		ram_hi[0x1C] = 0x9F;
		ram_hi[0x1D] = 0xBF;
		ram_hi[0x20] = 0xFF;
		ram_hi[0x21] = 0x00;
		ram_hi[0x22] = 0x00;
		ram_hi[0x23] = 0xBF;
		ram_hi[0x24] = 0x77;
		ram_hi[0x25] = 0xF3;
		ram_hi[0x26] = 0xF1;
		sound_dirty();
	}

	private void reset() {
		ch1_outflag = ch2_outflag = ch3_outflag = ch4_outflag = 0;

		ch1_cnt = ch1_cntflag = ch1_envcnt = ch1_swpcnt = 
		ch2_cnt = ch2_cntflag = ch2_envcnt = 
		ch3_cnt = ch3_cntflag = 
		ch4_cnt = ch4_cntflag = ch4_envcnt = 0;

		ch1_len = ch1_envlen = ch1_swplen = 
		ch2_len = ch2_envlen = 
		ch3_len = 
		ch4_len = ch4_envlen = 0;

		ch1_freq = ch2_freq = ch3_freq = ch4_freq = 0;
		
		ch1_envdir = ch1_envvol = 
		ch2_envdir = ch2_envvol = 
		ch4_envdir = ch4_envvol = 0;
	}

	private void sound_dirty() {
		ch1_envvol = ram_hi[0x12] >> 4;
		ch1_envdir = (ram_hi[0x12] >> 3) & 0x01;
		ch1_envdir |= ch1_envdir - 1;
		ch1_envlen = (ram_hi[0x12] & 0x07);
		ch1freq();
		
		ch2_envvol = ram_hi[0x17] >> 4;
		ch2_envdir = (ram_hi[0x17] >> 3) & 0x01;
		ch2_envdir |= ch2_envdir - 1;
		ch2_envlen = (ram_hi[0x17] & 0x07);
		ch2freq();
		
		ch3freq();
		ch4_envvol = ram_hi[0x21] >> 4;
		ch4_envdir = (ram_hi[0x21] >> 3) & 0x01;
		ch4_envdir |= ch4_envdir - 1;
		ch4_envlen = (ram_hi[0x21] & 0x07);
		ch4freq();
	}

	void doFrame() {

		int ch1_output;
		int ch2_output;
		int ch3_output;
		int ch4_output;

		if(ch1_outflag != 0) {
			ch1_output = ch1_envvol;

			ch1_cnt -= 256;
			if(ch1_cntflag != 0 && ch1_cnt <= 0) 
				ch1_outflag = 0;

			ch1_envcnt -= 256;
			if(ch1_envlen != 0) {
				while(ch1_envcnt <= 0) {
					ch1_envcnt += ch1_envlen * 60;
					ch1_envvol += ch1_envdir;
				}
				if(ch1_envvol < 0) ch1_envvol = 0;
				if(ch1_envvol > 15) ch1_envvol = 15;
			}

			ch1_swpcnt -= 128;
			if(ch1_swplen != 0) {
				while(ch1_swpcnt <= 0) {
					ch1_swpcnt += ch1_swplen * 60;

					int divclock;

					divclock = ch1_divclock;
					if(ch1_swpdir != 0) divclock -= divclock >> ch1_swpdep;
					else divclock += divclock >> ch1_swpdep;

					if(divclock > 2047) {
						ch1_outflag = 0;
					}
					else {
						ram_hi[0x13] = divclock & 0xFF;					
						ram_hi[0x14] = (ram_hi[0x14] & 0xF8) | divclock >> 8;					
						ch1freq();
					}
				}
			}
			
			if(ch1_pan == 0) ch1_output = 0;
			
		} else { ch1_output = 0; }

		if(ch2_outflag != 0) {
			ch2_output = ch2_envvol;

			ch2_cnt -= 256;
			if(ch2_cntflag != 0 && ch2_cnt <= 0) 
				ch2_outflag = 0;

			ch2_envcnt -= 256;
			if(ch2_envlen != 0) {
				while(ch2_envcnt <= 0) {
					ch2_envcnt += ch2_envlen * 60;
					ch2_envvol += ch2_envdir;
				}
				if(ch2_envvol < 0) ch2_envvol = 0;
				if(ch2_envvol > 15) ch2_envvol = 15;
			}
			
			if(ch2_pan == 0) ch2_output = 0;
			
		} else { ch2_output = 0; }

		if(ch3_outflag != 0) {
			ch3_output = ch3_outlvl;

			ch3_cnt -= 256;
			if(ch3_cntflag != 0 && ch3_cnt <= 0) 
				ch3_outflag = 0;
			
			if(ch3_pan == 0) ch3_output = 0;

		} else { ch3_output = 0; }

		if(ch4_outflag != 0) {
			ch4_output = ch4_envvol;

			ch4_cnt -= 256;
			if(ch4_cntflag != 0 && ch4_cnt <= 0) 
				ch4_outflag = 0;

			ch4_envcnt -= 256;
			if(ch4_envlen != 0) {
				while(ch4_envcnt <= 0) {
					ch4_envcnt += ch4_envlen * 60;
					ch4_envvol += ch4_envdir;
				}
				if(ch4_envvol < 0) ch4_envvol = 0;
				if(ch4_envvol > 15) ch4_envvol = 15;
			}
			
			if(ch4_pan == 0) ch4_output = 0;
			
		} else { ch4_output = 0; }

		ram_hi[0x26] =
			(ram_hi[0x26] & 0xF0) |
			(ch4_outflag << 3) |
			(ch3_outflag << 2) |
			(ch2_outflag << 1) |
			ch1_outflag;
		

		psgi.setChVolume(0, CH1_VOL[ch1_output]);
		psgi.setChVolume(1, CH2_VOL[ch2_output]);
		psgi.setChVolume(2, CH3_VOL[ch3_output]);
		psgi.setChVolume(3, CH4_VOL[ch4_output]);

		if(ch1_output != 0) {
			psgi.setChFreq(0, ch1_freq);
			psgi.setChTone(0, CH1_BANKNUM[ch1_duty]);
			psgi.setChPan(0, CH_PAN[ch1_pan]);
		}
		if(ch2_output != 0) {
			psgi.setChFreq(1, ch2_freq);
			psgi.setChTone(1, CH1_BANKNUM[ch2_duty]);
			psgi.setChPan(1, CH_PAN[ch2_pan]);
		}
		if(ch3_output != 0) {
			psgi.setChFreq(2, ch3_freq);
			//psgi.setChTone(2, CH3_BANKNUM);	//WaveCh͈ꉹFőp
			psgi.setChPan(2, CH_PAN[ch3_pan]);
		}
		if(ch4_output != 0) {
			psgi.setChFreq(3, ch4_freq);
			//psgi.setChTone(3, CH4_BANKNUM[ch4_seqmode]);	//mCYȗ
			psgi.setChPan(3, CH_PAN[ch4_pan]);
		}

		psgi.doFrame();
	}

	void writeReg(int addr, int data) {
		if((ram_hi[0x26] & 0x80) == 0 && addr != 0x26) return;

		//30 - 3F  `l3p̃Tv̈
		//if((addr & 0xF0) == 0x30) {
		//	if(ch3_outflag == 0)  ch3_wave[addr - 0x30] = ram_hi[addr] = data;
		//}

		switch(addr) {
		case 0x10:
			ram_hi[0x10] = data;
			ch1_swplen = (ram_hi[0x10] >> 4) & 0x07;
			ch1_swpdir = ram_hi[0x10] & 0x08;
			ch1_swpdep = ram_hi[0x10] & 0x07;
			ch1_divclock = (((ram_hi[0x14] & 0x07) << 8) + ram_hi[0x13]);
			break;
		case 0x11:
			ram_hi[0x11] = data;
			ch1_duty = ram_hi[0x11] >> 6;
			ch1_len = 64 - (ram_hi[0x11] & 0x63);
			break;
		case 0x12:
			ram_hi[0x12] = data;
			ch1_envvol = ram_hi[0x12] >> 4;
			ch1_envdir = (ram_hi[0x12] >> 3) & 0x01;
			ch1_envdir |= ch1_envdir - 1;
			ch1_envlen = ram_hi[0x12] & 0x07;
			break;
		case 0x13:
			ram_hi[0x13] = data;
			ch1freq();
			break;
		case 0x14:
			ram_hi[0x14] = data;
			ch1_cntflag = ram_hi[0x14] & 0x40;
			ch1freq();
			if((data & 0x80) != 0) ch1init();
			break;

		case 0x16:
			ram_hi[0x16] = data;
			ch2_duty = ram_hi[0x16] >> 6;
			ch2_len = 64 - (ram_hi[0x16] & 0x63);
			break;
		case 0x17:
			ram_hi[0x17] = data;
			ch2_envvol = ram_hi[0x17] >> 4;
			ch2_envdir = (ram_hi[0x17] >> 3) & 0x01;
			ch2_envdir |= ch2_envdir - 1;
			ch2_envlen = ram_hi[0x17] & 0x07;
			break;
		case 0x18:
			ram_hi[0x18] = data;
			ch2freq();
			break;
		case 0x19:
			ram_hi[0x19] = data;
			ch2_cntflag = ram_hi[0x19] & 0x40;
			ch2freq();
			if((data & 0x80) != 0) ch2init();
			break;

		case 0x1A:
			ram_hi[0x1A] = data;
			if((data & 0x80) == 0) ch3_outflag = 0;
			break;
		case 0x1B:
			ram_hi[0x1B] = data;
			ch3_len = 256 - ram_hi[0x1B];
			break;
		case 0x1C:
			ram_hi[0x1C] = data;
			ch3_outlvl = (ram_hi[0x1C] >> 5) & 0x03;
			break;
		case 0x1D:
			ram_hi[0x1D] = data;
			ch3freq();
			break;
		case 0x1E:
			ram_hi[0x1E] = data;
			ch3_cntflag = ram_hi[0x1E] & 0x40;
			ch3freq();
			if((data & 0x80) != 0) ch3init();
			break;

		case 0x20:
			ram_hi[0x20] = data;
			ch4_len = 64 - (ram_hi[0x20] & 0x63);
			break;
		case 0x21:
			ram_hi[0x21] = data;
			ch4_envvol = ram_hi[0x21] >> 4;
			ch4_envdir = (ram_hi[0x21] >> 3) & 0x01;
			ch4_envdir |= ch4_envdir - 1;
			ch4_envlen = ram_hi[0x21] & 0x07;
			break;
		case 0x22:
			ram_hi[0x22] = data;
			ch4_siftclock = ram_hi[0x22] >> 4;
			ch4_seqmode = (ram_hi[0x22] >> 3) & 0x01;
			ch4_divratio = ram_hi[0x22] & 0x07;
			ch4freq();
			break;
		case 0x23:
			ram_hi[0x23] = data;
			ch4_cntflag = ram_hi[0x23] & 0x40;
			ch4freq();
			if((data & 0x80) != 0) ch4init();
			break;

		case 0x24:		//J[gbW
			ram_hi[0x24] = data;
			break;
		case 0x25:		//XeIo͐
			ram_hi[0x25] = data;
			ch1_pan = ((data >> 3) & 0x02) + (data & 0x01);
			ch2_pan = ((data >> 4) & 0x02) + ((data >> 1) & 0x01);
			ch3_pan = ((data >> 5) & 0x02) + ((data >> 2) & 0x01);
			ch4_pan = ((data >> 6) & 0x02) + ((data >> 3) & 0x01);
			break;
		case 0x26:		//Xe[^X&p
			ram_hi[0x26] = data;
			if((data & 0x80) == 0) init();
			break;
		}

	}

	int readReg(int addr) {
		return ram_hi[addr];
	}

	GBApu(PSGi psgi_) {
		psgi = psgi_;
		ram_hi = new int[0xFF];
		ch3_wave = new int[0x0F];
		
		psgi.setChNoiseMode(3, true);
		psgi.setChTone(2, CH3_BANKNUM);
		psgi.setChTone(3, CH4_BANKNUM[0]);
	}
}
