import dojapcmsound.PcmAudioHandler;

public class GBPCM {
	public int hz, len;
	public boolean stereo;
	public byte[] buf;
	public int pos;
	private int delay;

	private PcmAudioHandler pcm;
	private int playCounter;

	//ݒ
	private boolean soundEnable;

	public GBPCM() {
		pcm = PcmAudioHandler.getPCMHandler(0);
		hz = pcm.getSampleRate();
	}
	
	public void setSoundEnable(boolean enable) {
		soundEnable = enable;
	}

	public void setVolume(int vol) {
		pcm.setVolume(vol);
	}

	public void setSampleRate(int rate) {
		pcm.setSampleRate(rate);
		hz = pcm.getSampleRate();
	}

	public void setSoundMode(int mode) {
		pcm = PcmAudioHandler.getPCMHandler(mode);
	}
	
	public void init() {
		pcm.clearSample();
	}
	
	public void write(int sample) {
		if(!soundEnable) return;
		pcm.writeSample(sample);
		playCounter++;
	}

	public void setDelay(int num){
		delay = num ;
	}
	
	public boolean submit() {
		if(playCounter >= hz / delay) 
			return true;
		else
			return false;
	}

	public void play() {
		if(!soundEnable) return;
		playCounter = 0;
		pcm.play();
	}

	public void close() {

	}
}
